package dk.aau.portal.mkr.cas_proxy.controllers.editor;

import java.io.IOException;
import java.util.HashMap;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jasig.cas.client.authentication.AttributePrincipal;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.DefaultClientConfig;

public class EditService extends HttpServlet {
	private static final String BUILDING_SERVICE_URL = "http://localhost:8080/building-service/";
	private static final long serialVersionUID = 1L;

	/** 
	 * Endpoint that makes the request to the building service.
	 * {@inheritDoc}
	 */
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		HashMap<String, Object> model = new HashMap<String, Object>();

		String proxyTicket = ((AttributePrincipal)req.getUserPrincipal()).getProxyTicketFor(BUILDING_SERVICE_URL);
		model.put("proxy_ticket", proxyTicket);
		
		Client client = Client.create(new DefaultClientConfig());
		WebResource webreq =  client.resource(BUILDING_SERVICE_URL);
		
		String secret = webreq.queryParam("ticket", proxyTicket).queryParam("msg", "GiefSecret").post(String.class);
		model.put("secret", secret);
		
		req.setAttribute("it", model);
		RequestDispatcher view  = getServletContext().getRequestDispatcher("/WEB-INF/jsp/fetcher.jsp");
		view.forward(req, resp);
	}

	
}
